<template>
  <div :class="themeClasses">
    <div class="branchs" ref="branchs">
      <div class="branch">{{ $t("group." + $route.params.groupId) }}</div>
    </div>
    <div
      ref="wrapper"
      :class="[
        'map-wrapper',
        loading && 'loading',
        expand && !isMobile && 'expand-map'
      ]"
    >
      <div class="container lp lp--large">
        <div class="expand"></div>
        <div
          :class="[
            'button-toggle-map',
            expand && 'expand-map',
            mapLoaded && !loading && 'visible'
          ]"
          @click="toggleMap()"
          :style="toggleButtonStyle"
        >
          <span class="text">{{
            expand ? $t("realMap.collapseMap") : $t("realMap.expandMap")
          }}</span>
          <span class="arrows">
            <i class="ic-sm-arrow left"></i>
            <i class="ic-sm-arrow right"></i>
          </span>
        </div>
        <button
          @click.stop="openMap"
          :class="[
            'map-btn',
            'map-btn--fullscreen',
            'pointer',
            !loading && 'visible'
          ]"
          aria-label="zoom"
        ></button>
        <real-map
          ref="realMap"
          @handleScroll="handleScroll"
          @mapLoaded="mapLoaded = true"
          :expand="expand"
          :image="mapSettings.image"
          :restaurants="restaurants"
        />
        <modal v-if="opened" @close="opened = false">
          <drag-hint v-if="opened && showHint" @onClick="onHintClick" />
          <real-map
            :scroll="true"
            @center="center = null"
            :image="mapSettings.image"
            :restaurants="restaurants"
          />
        </modal>
      </div>
    </div>
    <div v-if="loading" class="container m-container-no-gutter">
      <List />
    </div>
    <div v-else class="container m-container-no-gutter">
      <div class="building-desc">
        {{ $t("group." + $route.params.groupId) }}
      </div>
      <div class="restaurant-list">
        <restaurant-item
          v-for="r in restaurants"
          list-type="floor plan list"
          strategy="waiting"
          :key="r.id"
          :restaurant="r"
        />
      </div>
    </div>
  </div>
</template>

<script>
import _ from "underscore";
import RealMap from "./RealMap";
import { mapGetters, mapState } from "vuex";
import realmap from "../../const/realmap";
import List from "@/components/Group/List";
import RestaurantItem from "@/components/Group/RestaurantItem";
import Modal from "@/components/Modal";
import DragHint from "./DragHint";
import { setTimeout } from "timers";

export default {
  data() {
    return {
      mapLoaded: false,
      expand: false,
      opened: false,
      showHint: true,
      toggleButtonStyle: {}
    };
  },

  components: {
    DragHint,
    List,
    Modal,
    RealMap,
    RestaurantItem
  },

  props: {
    group: {
      type: Object
    },
    restaurants: {
      type: Array
    }
  },

  computed: {
    ...mapState("group", ["loading"]),
    ...mapGetters("theme", ["themeClasses"]),
    ...mapState(["isMobile"]),

    mapSettings() {
      const groupId = this.$route.params.groupId;
      return realmap[groupId];
    }
  },
  created() {
    window.addEventListener("scroll", this.handleScroll);
  },
  destroyed() {
    window.removeEventListener("scroll", this.handleScroll);
  },
  methods: {
    toggleMap() {
      this.expand = !this.expand;
      setTimeout(() => {
        if (this.expand) {
          const elem = this.$refs.realMap.$el;
          elem.scrollIntoView({ behavior: "smooth", block: "center" });
        } else {
          const elem = this.$refs.branchs;
          elem.scrollIntoView({ behavior: "auto", block: "start" });
        }
      }, 0);
    },
    handleScroll() {
      const elem = this.$refs.wrapper;
      if (!elem) return;
      let clientHeight = document.body.clientHeight;
      let rect = elem.getBoundingClientRect();
      if (rect.top + 90 > clientHeight) {
        this.toggleButtonStyle = {
          position: "absolute",
          top: "20px"
        };
      } else if (clientHeight > rect.bottom) {
        this.toggleButtonStyle = {
          position: "absolute",
          bottom: "20px"
        };
      } else {
        this.toggleButtonStyle = {
          position: "fixed",
          bottom: "20px"
        };
      }
    },
    openMap() {
      this.opened = true;
      this.showHint = true;
      if (this.showHint) {
        setTimeout(() => {
          this.showHint = false;
        }, 3000);
      }
    },
    onHintClick() {
      this.showHint = false;
    }
  }
};
</script>

<style lang="scss" scoped>
.map-wrapper {
  width: 100%;
  overflow: hidden;

  &.expand-map {
    overflow-y: visible;
    overflow-x: scroll;
    .container {
      padding: 0px;
      .expand {
        display: none;
      }
    }
  }

  .container {
    position: relative;
    top: 0;
    left: 0;
    right: 0;
    margin-left: auto;
    margin-right: auto;
    height: 100%;
    max-width: 3748px;

    .expand {
      display: block;
      width: 100%;
      padding-bottom: 36.25%;
    }

    @include media-breakpoint-down(sm) {
      .expand {
        padding-bottom: 70%;
      }
    }

    @include media-breakpoint-down(xl) {
      margin: 0;
      padding: 0;
      max-width: none;
    }

    @include media-breakpoint-up(xxl) {
      &:before,
      &:after {
        content: "";
        position: absolute;
        width: 40px;
        height: 100%;
        top: 0;
        z-index: 1;
      }

      &:before {
        left: 0;
        background: linear-gradient(to right, #f5e8e5 0%, transparent 100%);
      }

      &:after {
        right: 0;
        background: linear-gradient(to left, #f5e8e5 0%, transparent 100%);
      }
    }
    .map-btn {
      display: none;
      z-index: 1;
      width: 40px;
      height: 40px;
      border: none;
      border-radius: 3px;
      box-shadow: 0 2px 3px 2px rgba($color-secondary-black, 0.3);

      &--fullscreen {
        position: absolute;
        right: 20px;
        bottom: 20px;
        background: $color-white url("/static/images/ic-fullscreen.svg")
          center/contain no-repeat;
        transition: all 0.3s;

        &:hover,
        &:active {
          transform: scale(0.9);
        }
      }
    }
    @include media-breakpoint-down(sm) {
      .map-btn {
        &.visible {
          display: block;
        }
      }
    }

    .button-toggle-map {
      width: 174px;
      height: 48px;
      display: none;
      background-color: $color-skm-red;
      position: fixed;
      left: calc((100% - 174px) / 2);
      z-index: 1000;
      box-shadow: 0 2px 10px 0 rgba(0, 0, 0, 0.3);
      border-radius: 24px;
      color: $color-white;
      flex-direction: row;
      align-items: center;
      justify-content: center;
      cursor: pointer;
      .text {
        margin-left: 8px;
        flex-grow: 2;
        text-align: center;
      }
      .arrows {
        margin-right: 10px;
      }
      .ic-sm-arrow {
        position: relative;
        display: block;
        width: 15px;
        &:before {
          position: absolute;
          font-size: 8px;
          top: 50%;
          left: 50%;
        }
        &.left {
          &:before {
            transition: all 0.5s ease-in-out;
            transform: translate(-20px, -11px) rotate(180deg);
          }
        }
        &.right {
          &:before {
            transition: all 0.5s ease-in-out;
            transform: translate(-20px, 1px) rotate(0deg);
          }
        }
      }
      &.expand-map {
        .ic-sm-arrow {
          &.left {
            &:before {
              transition: all 0.5s ease-in-out;
              transform: translate(-20px, -11px) rotate(0deg);
            }
          }
          &.right {
            &:before {
              transition: all 0.5s ease-in-out;
              transform: translate(-20px, 1px) rotate(180deg);
            }
          }
        }
      }
      &.visible {
        @include media-breakpoint-up(md) {
          display: inline-flex;
        }
      }
    }
  }
}

.branchs {
  height: 54px;
  text-align: center;
  font-size: 16px;
  background: $color-white;
}

.branch {
  display: inline-block;
  padding: 0 48px;
  line-height: 54px;
  height: 54px;
  box-sizing: border-box;
  border-bottom: 3px solid $color-skm-red;
  color: $color-skm-red;
}

.theme-vip-member .building-desc {
  background-color: $color-gold-100;
}

.building-desc {
  padding: $grid-gutter-width $grid-gutter-width/2 $grid-gutter-width/2
    $grid-gutter-width/2;
  background-color: $color-genesis-white;
  font-size: 18px;
  color: $color-primary-grey;

  @include media-breakpoint-up(md) {
    font-size: 28px;
    text-align: center;
    color: $color-primary-black;
    padding: 60px 0 30px 0;
  }
}

.theme-vip-member .floor-desc {
  background-color: $color-gold-100;
}

.floor-desc {
  padding: $grid-gutter-width/2;
  justify-content: space-between;
  align-items: flex-end;
  background-color: $color-genesis-white;

  &__name {
    font-size: 18px;
  }
  &__restaurants-count {
    font-size: 14px;
    color: $color-secondary-black;
  }

  @include media-breakpoint-up(md) {
    padding: 0;
    align-items: center;
    &__name {
      font-size: 28px;
    }
    &__restaurants-count {
      font-size: 16px;
    }
  }
}

.restaurant-list {
  @include media-breakpoint-up(md) {
    padding: 20px 0;
    display: flex;
    flex-flow: row wrap;
    margin-left: -15px;
    margin-right: -15px;
  }
}
</style>
